﻿package{
	
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Stage;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.geom.Matrix;
	
	public class IntuitiveDrawer extends Sprite{
		
		var bg:BitmapData;
		var container:Bitmap;
		var line:Sprite;
		var lineCopy:Sprite;
		var lineCopy2:Sprite;
		var lineCopy3:Sprite;
		var lineCopy4:Sprite;
		var lineStack:Array;
		var matrix:Matrix;
		var matrix2:Matrix;
		var matrix3:Matrix;
		var matrix4:Matrix;		
		public function IntuitiveDrawer():void{
			
			bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			container = new Bitmap(bg);
			addChild(container);
			
			stage.addEventListener(MouseEvent.MOUSE_DOWN,startDessine);
			stage.addEventListener(MouseEvent.MOUSE_MOVE,dessine);
			stage.addEventListener(MouseEvent.MOUSE_UP,stopDessine);
		
			}
			
		private function startDessine(e:MouseEvent):void{
			removeEventListener(Event.ENTER_FRAME,floodit);
			matrix = new Matrix();
			matrix2 = new Matrix();
			matrix3 = new Matrix();
			matrix4 = new Matrix();
			line = new Sprite();
			lineStack = new Array();
			line.graphics.lineStyle(3,0xcccFFF,1);
			line.graphics.moveTo(e.stageX,e.stageY);
			lineStack.push(new Array(e.stageX,e.stageY));
			}
		
		private function dessine(e:MouseEvent):void{
			if(line != null){
				//line.graphics.lineTo(e.stageX,e.stageY);
				lineStack.push(new Array(e.stageX,e.stageY));
				//lineStack.push(new Array(e.stageX,e.stageY));
				addChild(line);
				}
			}
		
		private function stopDessine(e:MouseEvent):void{
			if(line != null){
				removeChild(line);
				line = null;
				floodFill();
			}
		}
		
		private function floodFill():void{
			lineCopy= new Sprite();
			lineCopy2= new Sprite();
			lineCopy3= new Sprite();
			lineCopy4= new Sprite();
			
			lineCopy.graphics.lineStyle(1,buildColor(),0.1);
			lineCopy2.graphics.lineStyle(1,buildColor(),0.1);
			lineCopy3.graphics.lineStyle(1,buildColor(),0.1);
			lineCopy4.graphics.lineStyle(1,buildColor(),0.1);
			
			lineCopy.graphics.moveTo(lineStack[0][0],lineStack[0][2]);
			lineCopy2.graphics.moveTo(lineStack[0][0],lineStack[0][2]);
			lineCopy3.graphics.moveTo(lineStack[0][0],lineStack[0][2]);
			lineCopy4.graphics.moveTo(lineStack[0][0],lineStack[0][2]);
			
			for(var i:uint=1;i<lineStack.length;i++){
				lineCopy.graphics.lineTo(lineStack[i][0],lineStack[0][2]);
				lineCopy2.graphics.lineTo(lineStack[i][0],lineStack[0][2]);
				lineCopy3.graphics.lineTo(lineStack[i][0],lineStack[0][2]);
				lineCopy4.graphics.lineTo(lineStack[i][0],lineStack[0][2]);
				}
			addEventListener(Event.ENTER_FRAME,floodit);
			}
		private function floodit(e:Event):void{
			
			matrix.scale(0.999999,1.04);
			matrix2.scale(0.999999,1.045);
			matrix3.scale(0.999999,1.05);
			matrix4.scale(0.999999,1.055);
			//matrix.scale(0.99,1.0);
			bg.draw(lineCopy4,matrix4);
			bg.draw(lineCopy3,matrix3);
			bg.draw(lineCopy2,matrix2);
			bg.draw(lineCopy,matrix);
			
			//bg.draw(lineCopy,-matrix);
			}
			
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():uint{
			var R:uint = Math.round(Math.random()*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var nbr:uint =  R << 16 | G << 8 | B;
			return nbr;
			trace (nbr)
			}
	}
	
}